/* Copyright (C) David Wolfe, 1990.  All rights reserved. */

/* Maintains an 2 dimensional bit array */

typedef struct B_struct {
	int x;
	int y;
	unsigned *contents;
} *B_type;

#define SpOt(a,i,j) ((i) * (a)->y + (j))
#define ByTe(a,i,j) ((a)->contents + (SpOt(a,i,j) / INT_SIZE))
#define BiT(a,i,j) (SpOt(a,i,j) % INT_SIZE)

#define B_get(a,i,j)   ((*ByTe(a,i,j) &   (1<<BiT(a,i,j))) != 0)
#define B_set(a,i,j)   ( *ByTe(a,i,j) |=  (1<<BiT(a,i,j)))
#define B_clear(a,i,j) ( *ByTe(a,i,j) &= ~(1<<BiT(a,i,j)))
#define B_free(a) (free ((a)->contents), free (a))
#define B_x(a) ((a)->x)
#define B_y(a) ((a)->y)

extern B_type			B_make (int, int);
extern list_type		B_to_list (B_type);
extern B_type			B_pack (B_type);
extern void			B_printf (B_type);
extern B_type			B_copy (B_type);
extern B_type			B_copy_offset (B_type, int, int, int, int);
extern B_type			B_expand (B_type, int, int);
extern B_type			B_transpose (B_type);
extern int			B_flip (B_type);
extern int			B_min_occupied_x(B_type);
extern int			B_max_occupied_x(B_type);
extern int			B_min_occupied_y(B_type);
extern int			B_max_occupied_y(B_type);
