/* Copyright (C) David Wolfe, 1990.  All rights reserved. */
/* Includes mostly code written by David Moews */

%%
stat					{return STAT;}
freeze					{return FREEZE;}
chill[\n]				{printf ("%s", chill_string); return EOS;}
warm[\n]				{printf ("%s", warm_string);  return EOS;}
chill[^\n]*[\n]				{strcpy (chill_string, yytext+5); return EOS;}
warm[^\n]*[\n]				{strcpy (warm_string, yytext+5); return EOS;}
on					{return ON;}
off					{return OFF;}
mean					{return MEAN;}
temperature				{return TEMPERATURE;}
temp					{return TEMPERATURE;}
aw					{return AW;}
integers				{return INTEGERS;}
numbers					{return NUMBERS;}
stars					{return STARS;}
ups					{return UPS;}
zeros					{return ZEROS;}
tinys					{return TINYS;}
tinies					{return TINYS;}
ons					{return ONS;}
variables				{return VARS;}
expand					{return EXPAND;}
all					{return ALL;}
prompt					{return PROMPT;}
evaluate				{return EVALUATE;}
eval					{return EVALUATE;}
normalize				{return NORMALIZE;}
normal					{return NORMALIZE;}
norm					{return NORMALIZE;}
echo					{return ECHO_;}
assume					{return ASSUME;}
assume2					{return ASSUME2;}
reset					{return RESET;}
clean					{return CLEAN;}
tex					{return TEX;}
no					{return NO;}
help[ \t]*[a-zA-Z]*			{char *s;
					 for (s = yytext+4; *s == ' ' || *s == '\t'; s++);
					 strcpy (help_file, s);
					 for (s = help_file; *s != '\0'; s++)
						 if (islower (*s)) *s = toupper (*s);
					 return HELP;
					}
corridor				{return CORRIDOR;}
corr					{return CORRIDOR;}
cor					{return CORRIDOR;}
domineering				{return DOMINO;}
domineer				{return DOMINO;}
domino					{return DOMINO;}
dom					{return DOMINO;}
konane					{return KONANE;}
kon					{return KONANE;}
toads					{return TOADS;}	/* Toads & Frogs */
domstr					{return DOMSTR;}/* Domineering strings */
sowing					{return SOWING;}/* Conway's Sowing */
sow					{return SOWING;}/* Conway's Sowing */
isow					{return ISOWING;}/* Guy's impartial Sowing */
mancala					{return MANCALA;}/* Mancala */
man					{return MANCALA;}/* Mancala */
revman					{return REVMANCALA;}/* Mancala */
hotman					{return HOTMANCALA;}/* Hot Mancala */
coldman					{return COLDMANCALA;}/* Cold Mancala */
wari					{return WARI;}/* Wari */
iwari					{return IWARI;}/* Impartial Wari */
trace					{return TRACE;}	/* enable trace output */
ish					{return ISH;} /* print "-ish" output */
saltus					{return SALTUS;}
period					{return PERIOD;}
tweak					{return TWEAK;}
#.*					; /* Comment */
"|"					{return BAR;}
"||"					{return BARR;}
"|||"					{return BARRR;}
"||||"					{return BARRRR;}
"|||||"					{return BARRRRR;}
"|0<"[0-9]+">"				{extern int atoi();
					 yylval.ival = atoi(yytext+3);
					 return BARZEROS;}
0"<"[0-9]+">"					{extern int atoi();
					 yylval.ival = atoi(yytext+2);
					 return ZEROS;}
0|[1-9][0-9]*				{extern int atoi();
					 yylval.ival = atoi(yytext);
					 return NUM;}
"<("[1-9][0-9]*")>"			{extern int atoi();
					 yylval.ival = atoi(yytext+2);
					 return ONNUM;}
"<to "[1-9][0-9]*">"			{extern int atoi();
					 yylval.ival = atoi(yytext+4);
					 return ONNUM;}
[<>%?\+\(\)\{\}\[\]\.\-\^\*v,\/=Kk]	{return *yytext;}
"-K"					{return MINUS_K;}
"-k"					{return MINUS_k;}
"+"/"["					{return TINY;}
"-"/"["					{return MINY;}
[\n]					{return EOS;}
[ \t]					{}
[bu]/[0-9]				{return *yytext;}
v*['\1'$a-uw-zA-Z_][a-zA-Z_0-9]*	{yylval.lval = make_var (yytext);
					 return S;}
.					{return UNKNOWN;}
%%
int yywrap()
{
	return 1;
}

#define my_getc() (*(parser_input++))
#undef input
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):my_getc())==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)

#ifdef IBMPC
char *strdup (s)
	char *s;
{
	char *t, *malloc();
	t = malloc (strlen (s) + 1);
	strcpy (t, s);
	return t;
}
#endif
